from PyQt5.QtWidgets import *
import numpy as np
import math
from scipy.optimize import curve_fit
import matplotlib.pyplot as plt
class MainWindow(QWidget):
    def __init__(self,parent=None):
        super(MainWindow,self).__init__(parent)

        self.a = QLineEdit()
        self.a.setFixedWidth(110)
        self.b = QLineEdit()
        self.b.setFixedWidth(110)
        self.c = QLineEdit()
        self.c.setFixedWidth(110)
        self.d = QLineEdit()
        self.d.setFixedWidth(110)
        self.e = QLineEdit()
        self.e.setFixedWidth(110)
        self.f = QLineEdit()
        self.f.setFixedWidth(110)
        self.g = QLineEdit()
        self.g.setFixedWidth(110)
        self.h = QLineEdit()
        self.h.setFixedWidth(110)
        self.i = QLineEdit()
        self.i.setFixedWidth(110)
        self.j = QLineEdit()
        self.j.setFixedWidth(110)
        self.k = QLineEdit()
        self.k.setFixedWidth(110)
        self.l = QLineEdit()
        self.l.setFixedWidth(110)
        self.m = QLineEdit()
        self.m.setFixedWidth(110)
        self.n = QLineEdit()
        self.n.setFixedWidth(110)
        self.o = QLineEdit()
        self.o.setFixedWidth(110)
        self.p = QLineEdit()
        self.p.setFixedWidth(110)
        self.q = QLineEdit()
        self.q.setFixedWidth(110)
        self.r = QLineEdit()
        self.r.setFixedWidth(110)
        self.s = QLineEdit()
        self.s.setFixedWidth(110)
        self.t = QLineEdit()
        self.t.setFixedWidth(110)
        self.u = QLineEdit()
        self.u.setFixedWidth(110)
        self.v = QLineEdit()
        self.v.setFixedWidth(110)
        self.w = QLineEdit()
        self.w.setFixedWidth(110)
        self.x = QLineEdit()
        self.x.setFixedWidth(110)
        self.y = QLineEdit()
        self.y.setFixedWidth(110)
        self.z = QLineEdit()
        self.z.setFixedWidth(110)
        self.a1 = QLineEdit()
        self.a1.setFixedWidth(110)
        self.b1 = QLineEdit()
        self.b1.setFixedWidth(110)
        self.c1 = QLineEdit()
        self.c1.setFixedWidth(110)
        self.d1 = QLineEdit()
        self.d1.setFixedWidth(110)
        self.e1 = QLineEdit()
        self.e1.setFixedWidth(110)
        self.f1 = QLineEdit()
        self.f1.setFixedWidth(110)
        self.g1 = QLineEdit()
        self.g1.setFixedWidth(110)
        self.h1 = QLineEdit()
        self.h1.setFixedWidth(110)
        self.i1 = QLineEdit()
        self.i1.setFixedWidth(110)
        self.j1 = QLineEdit()
        self.j1.setFixedWidth(110)
        self.k1 = QLineEdit()
        self.k1.setFixedWidth(110)
        self.l1 = QLineEdit()
        self.l1.setFixedWidth(110)
        self.m1 = QLineEdit()
        self.m1.setFixedWidth(110)
        self.n1 = QLineEdit()
        self.n1.setFixedWidth(110)
        self.o1 = QLineEdit()
        self.o1.setFixedWidth(110)
        self.p1 = QLineEdit()
        self.p1.setFixedWidth(110)
        self.q1 = QLineEdit()
        self.q1.setFixedWidth(110)
        self.r1 = QLineEdit()
        self.r1.setFixedWidth(110)
        self.s1 = QLineEdit()
        self.s1.setFixedWidth(110)
        self.t1 = QLineEdit()
        self.t1.setFixedWidth(110)
        self.u1 = QLineEdit()
        self.u1.setFixedWidth(110)
        self.v1 = QLineEdit()
        self.v1.setFixedWidth(110)
        self.w1 = QLineEdit()
        self.w1.setFixedWidth(110)
        self.x1 = QLineEdit()
        self.x1.setFixedWidth(110)
        self.y1 = QLineEdit()
        self.y1.setFixedWidth(110)
        self.z1 = QLineEdit()
        self.z1.setFixedWidth(110)
        self.a2 = QLineEdit()
        self.a2.setFixedWidth(110)
        self.b2 = QLineEdit()
        self.b2.setFixedWidth(110)
        self.c2 = QLineEdit()
        self.c2.setFixedWidth(110)
        self.d2 = QLineEdit()
        self.d2.setFixedWidth(110)
        self.e2 = QLineEdit()
        self.e2.setFixedWidth(110)
        self.f2 = QLineEdit()
        self.f2.setFixedWidth(110)
        self.g2 = QLineEdit()
        self.g2.setFixedWidth(110)
        self.h2 = QLineEdit()
        self.h2.setFixedWidth(110)
        self.i2 = QLineEdit()
        self.i2.setFixedWidth(110)
        self.j2 = QLineEdit()
        self.j2.setFixedWidth(110)
        self.k2 = QLineEdit()
        self.k2.setFixedWidth(110)
        self.l2 = QLineEdit()
        self.l2.setFixedWidth(110)
        self.m2 = QLineEdit()
        self.m2.setFixedWidth(110)
        self.n2 = QLineEdit()
        self.n2.setFixedWidth(110)
        self.o2 = QLineEdit()
        self.o2.setFixedWidth(110)
        self.p2 = QLineEdit()
        self.p2.setFixedWidth(110)
        self.q2 = QLineEdit()
        self.q2.setFixedWidth(110)
        self.r2 = QLineEdit()
        self.r2.setFixedWidth(110)
        self.s2 = QLineEdit()
        self.s2.setFixedWidth(110)
        self.t2 = QLineEdit()
        self.t2.setFixedWidth(110)
        self.u2 = QLineEdit()
        self.u2.setFixedWidth(110)
        self.v2 = QLineEdit()
        self.v2.setFixedWidth(110)
        self.w2 = QLineEdit()
        self.w2.setFixedWidth(110)
        self.x2 = QLineEdit()
        self.x2.setFixedWidth(110)
        self.y2 = QLineEdit()
        self.y2.setFixedWidth(110)
        self.z2 = QLineEdit()
        self.z2.setFixedWidth(110)
        self.a3 = QLineEdit()
        self.a3.setFixedWidth(110)
        self.b3 = QLineEdit()
        self.b3.setFixedWidth(110)
        self.c3 = QLineEdit()
        self.c3.setFixedWidth(110)
        self.d3 = QLineEdit()
        self.d3.setFixedWidth(110)
        self.e3 = QLineEdit()
        self.e3.setFixedWidth(110)
        self.f3 = QLineEdit()
        self.f3.setFixedWidth(110)
        self.g3 = QLineEdit()
        self.g3.setFixedWidth(110)
        self.h3 = QLineEdit()
        self.h3.setFixedWidth(110)
        self.i3 = QLineEdit()
        self.i3.setFixedWidth(110)
        self.j3 = QLineEdit()
        self.j3.setFixedWidth(110)
        self.k3 = QLineEdit()
        self.k3.setFixedWidth(110)
        self.l3 = QLineEdit()
        self.l3.setFixedWidth(110)
        self.m3 = QLineEdit()
        self.m3.setFixedWidth(110)
        self.n3 = QLineEdit()
        self.n3.setFixedWidth(110)
        self.o3 = QLineEdit()
        self.o3.setFixedWidth(110)
        self.p3 = QLineEdit()
        self.p3.setFixedWidth(110)
        self.q3 = QLineEdit()
        self.q3.setFixedWidth(110)
        self.r3 = QLineEdit()
        self.r3.setFixedWidth(110)
        self.s3 = QLineEdit()
        self.s3.setFixedWidth(110)
        self.t3 = QLineEdit()
        self.t3.setFixedWidth(110)
        self.u3 = QLineEdit()
        self.u3.setFixedWidth(110)
        self.v3 = QLineEdit()
        self.v3.setFixedWidth(110)
        self.w3 = QLineEdit()
        self.w3.setFixedWidth(110)
        self.x3 = QLineEdit()
        self.x3.setFixedWidth(110)
        self.y3 = QLineEdit()
        self.y3.setFixedWidth(110)
        self.z3 = QLineEdit()
        self.z3.setFixedWidth(110)
        self.a4 = QLineEdit()
        self.a4.setFixedWidth(110)
        self.b4 = QLineEdit()
        self.b4.setFixedWidth(110)
        self.c4 = QLineEdit()
        self.c4.setFixedWidth(110)
        self.d4 = QLineEdit()
        self.d4.setFixedWidth(110)
        self.e4 = QLineEdit()
        self.e4.setFixedWidth(110)
        self.f4 = QLineEdit()
        self.f4.setFixedWidth(110)
        self.g4 = QLineEdit()
        self.g4.setFixedWidth(110)
        self.h4 = QLineEdit()
        self.h4.setFixedWidth(110)
        self.i4 = QLineEdit()
        self.i4.setFixedWidth(110)
        self.j4 = QLineEdit()
        self.j4.setFixedWidth(110)

        self.graphshow1 = QPushButton("Ex1_Graph1",self)
        self.graphshow1.clicked.connect(self.GraphShow1)
        self.graphshow2 = QPushButton("Ex1_Graph2",self)
        self.graphshow2.clicked.connect(self.GraphShow2)
        self.graphshow3 = QPushButton("Ex1_Graph3",self)
        self.graphshow3.clicked.connect(self.GraphShow3)
        self.graphshow4 = QPushButton("Ex2_Graph1",self)
        self.graphshow4.clicked.connect(self.GraphShow4)
        self.graphshow5 = QPushButton("Ex2_Graph2",self)
        self.graphshow5.clicked.connect(self.GraphShow5)
        self.graphshow6 = QPushButton("Ex2_Graph3",self)
        self.graphshow6.clicked.connect(self.GraphShow6)


        self.calculate1 = QPushButton("Ex1_calc1")
        self.calculate1.clicked.connect(self.Calculate1)
        self.calculate2 = QPushButton("Ex1_calc2")
        self.calculate2.clicked.connect(self.Calculate2)
        self.calculate3 = QPushButton("Ex1_calc3")
        self.calculate3.clicked.connect(self.Calculate3)
        self.calculate4 = QPushButton("Ex2_calc1")
        self.calculate4.clicked.connect(self.Calculate4)
        self.calculate5 = QPushButton("Ex2_calc2")
        self.calculate5.clicked.connect(self.Calculate5)
        self.calculate6 = QPushButton("Ex2_calc3")
        self.calculate6.clicked.connect(self.Calculate6)
    

        self.a.setText("222.5")
        self.b.setText("254.7")
        self.c.setText("280.3")
        self.d.setText("282.3")
        self.e.setText("268.3")
        self.f.setText("246.3")
        self.g.setText("219.5")
        self.h.setText("180.5")
        self.i.setText("128.3")
        self.j.setText("76.2")
        self.k.setText("34.3")
        self.l.setText("8.0")
        self.m.setText("3.1")
        self.n.setText("13.1")
        self.o.setText("42.5")
        self.p.setText("83.9")
        self.q.setText("146.0")
        self.r.setText("202.7")
        self.s.setText("239.2") 
        self.t.setText("224.1")
        self.u.setText("264.2")
        self.v.setText("285.7")
        self.w.setText("287.5")
        self.x.setText("280.0")
        self.y.setText("260.2")
        self.z.setText("225.7")
        self.a1.setText("179.0")
        self.b1.setText("125.8")
        self.c1.setText("74.4")
        self.d1.setText("31.9")
        self.e1.setText("7.7")
        self.f1.setText("3.0")
        self.g1.setText("12.7")
        self.h1.setText("42.8")
        self.i1.setText("93.9")
        self.j1.setText("142.0")
        self.k1.setText("193.6")
        self.l1.setText("244.2")
        self.m1.setText("234.4")
        self.n1.setText("279.8")
        self.o1.setText("298.2")
        self.p1.setText("296.0")
        self.q1.setText("290.0")
        self.r1.setText("270.2")
        self.s1.setText("237.6")
        self.t1.setText("188.0")
        self.u1.setText("130.0")
        self.v1.setText("74.2")
        self.w1.setText("32.4")
        self.x1.setText("7.6")
        self.y1.setText("2.2")
        self.z1.setText("14.0")
        self.a2.setText("48.0")
        self.b2.setText("100.0")
        self.c2.setText("158.8")
        self.d2.setText("210.0")
        self.e2.setText("250.4")
        self.f2.setText("167.6")
        self.g2.setText("212.0")
        self.h2.setText("244.4")
        self.i2.setText("266.2")
        self.j2.setText("273.6")
        self.k2.setText("265.4")
        self.l2.setText("240.2")
        self.m2.setText("200.0")
        self.n2.setText("153.8")
        self.o2.setText("102.2")
        self.p2.setText("58.2")
        self.q2.setText("24.0")
        self.r2.setText("4.0")
        self.s2.setText("2.0")
        self.t2.setText("10.2")
        self.u2.setText("39.6")
        self.v2.setText("78.0")
        self.w2.setText("126.0")
        self.y2.setText("174.2")
        self.x2.setText("168.4")
        self.z2.setText("214.4")
        self.a3.setText("248.2")
        self.b3.setText("270.2")
        self.c3.setText("273.0")
        self.d3.setText("263.8")
        self.e3.setText("240.2")
        self.f3.setText("200.0")
        self.g3.setText("153.8")
        self.h3.setText("101.0")
        self.i3.setText("57.6")
        self.j3.setText("24.2")
        self.k3.setText("4.2")
        self.l3.setText("2.2")
        self.m3.setText("10.6")
        self.n3.setText("40.0")
        self.o3.setText("80.0")
        self.p3.setText("128.0")
        self.q3.setText("176.2")
        self.r3.setText("169.8")
        self.s3.setText("211.8")
        self.t3.setText("243.0")
        self.u3.setText("263.6")
        self.v3.setText("268.0")
        self.w3.setText("256.2")
        self.y3.setText("232.2")
        self.x3.setText("193.8")
        self.z3.setText("147.8")
        self.a4.setText("96.6")
        self.b4.setText("55.0")
        self.c4.setText("22.0")
        self.d4.setText("4.0")
        self.e4.setText("2.0")
        self.f4.setText("10.2")
        self.g4.setText("40.0")
        self.h4.setText("78.4")
        self.i4.setText("123.8")
        self.j4.setText("150.6")

        self.resultList = QTextEdit()
        self.resultList.setMaximumHeight(100)
        self.resultList.setText("")

        mainLayout = QGridLayout()
        mainLayout.addWidget(QLabel("実験1"),0,0)
        mainLayout.addWidget(QLabel("first"),0,1)
        mainLayout.addWidget(QLabel("second"),0,2)
        mainLayout.addWidget(QLabel("third"),0,3)
        mainLayout.addWidget(QLabel("実験2"),0,4)
        mainLayout.addWidget(QLabel("first"),0,5)
        mainLayout.addWidget(QLabel("second"),0,6)
        mainLayout.addWidget(QLabel("third"),0,7)
        mainLayout.addWidget(QLabel("-90"),1,0)
        mainLayout.addWidget(self.a,1,1)  
        mainLayout.addWidget(self.t,1,2)     
        mainLayout.addWidget(self.m1,1,3)
        mainLayout.addWidget(self.f2,1,5)
        mainLayout.addWidget(self.y2,1,6)
        mainLayout.addWidget(self.r3,1,7)
        mainLayout.addWidget(QLabel("-80"),2,0)
        mainLayout.addWidget(self.b,2,1)
        mainLayout.addWidget(self.u,2,2)
        mainLayout.addWidget(self.n1,2,3)
        mainLayout.addWidget(self.g2,2,5)
        mainLayout.addWidget(self.z2,2,6)
        mainLayout.addWidget(self.s3,2,7)
        mainLayout.addWidget(QLabel("-70"),3,0)
        mainLayout.addWidget(self.c,3,1)  
        mainLayout.addWidget(self.v,3,2)
        mainLayout.addWidget(self.o1,3,3)
        mainLayout.addWidget(self.h2,3,5) 
        mainLayout.addWidget(self.a3,3,6) 
        mainLayout.addWidget(self.t3,3,7) 
        mainLayout.addWidget(QLabel("-60"),4,0)
        mainLayout.addWidget(self.d,4,1)
        mainLayout.addWidget(self.w,4,2)
        mainLayout.addWidget(self.p1,4,3)
        mainLayout.addWidget(self.i2,4,5)
        mainLayout.addWidget(self.b3,4,6)
        mainLayout.addWidget(self.u3,4,7)
        mainLayout.addWidget(QLabel("-50"),5,0)
        mainLayout.addWidget(self.e,5,1) 
        mainLayout.addWidget(self.x,5,2)
        mainLayout.addWidget(self.q1,5,3)
        mainLayout.addWidget(self.j2,5,5)
        mainLayout.addWidget(self.c3,5,6)
        mainLayout.addWidget(self.v3,5,7)           
        mainLayout.addWidget(QLabel("-40"),6,0)
        mainLayout.addWidget(self.f,6,1)    
        mainLayout.addWidget(self.y,6,2)
        mainLayout.addWidget(self.r1,6,3)
        mainLayout.addWidget(self.k2,6,5)
        mainLayout.addWidget(self.d3,6,6)
        mainLayout.addWidget(self.w3,6,7)
        mainLayout.addWidget(QLabel("-30"),7,0)
        mainLayout.addWidget(self.g,7,1)
        mainLayout.addWidget(self.z,7,2)
        mainLayout.addWidget(self.s1,7,3)
        mainLayout.addWidget(self.l2,7,5)
        mainLayout.addWidget(self.e3,7,6)
        mainLayout.addWidget(self.x3,7,7)
        mainLayout.addWidget(QLabel("-20"),8,0)
        mainLayout.addWidget(self.h,8,1)
        mainLayout.addWidget(self.a1,8,2)
        mainLayout.addWidget(self.t1,8,3)
        mainLayout.addWidget(self.m2,8,5)
        mainLayout.addWidget(self.f3,8,6)
        mainLayout.addWidget(self.y3,8,7)
        mainLayout.addWidget(QLabel("-10"),9,0)
        mainLayout.addWidget(self.i,9,1)
        mainLayout.addWidget(self.b1,9,2)
        mainLayout.addWidget(self.u1,9,3)
        mainLayout.addWidget(self.n2,9,5)
        mainLayout.addWidget(self.g3,9,6)
        mainLayout.addWidget(self.z3,9,7)
        mainLayout.addWidget(QLabel("0"),10,0)
        mainLayout.addWidget(self.j,10,1)
        mainLayout.addWidget(self.c1,10,2)
        mainLayout.addWidget(self.v1,10,3)
        mainLayout.addWidget(self.o2,10,5)
        mainLayout.addWidget(self.h3,10,6)
        mainLayout.addWidget(self.a4,10,7)
        mainLayout.addWidget(QLabel("10"),11,0)
        mainLayout.addWidget(self.k,11,1)
        mainLayout.addWidget(self.d1,11,2)
        mainLayout.addWidget(self.w1,11,3)
        mainLayout.addWidget(self.p2,11,5)
        mainLayout.addWidget(self.i3,11,6)
        mainLayout.addWidget(self.b4,11,7)
        mainLayout.addWidget(QLabel("20"),12,0)
        mainLayout.addWidget(self.l,12,1)
        mainLayout.addWidget(self.e1,12,2)
        mainLayout.addWidget(self.x1,12,3)
        mainLayout.addWidget(self.q2,12,5)
        mainLayout.addWidget(self.j3,12,6)
        mainLayout.addWidget(self.c4,12,7)
        mainLayout.addWidget(QLabel("30"),13,0)
        mainLayout.addWidget(self.m,13,1)
        mainLayout.addWidget(self.f1,13,2)
        mainLayout.addWidget(self.y1,13,3)
        mainLayout.addWidget(self.r2,13,5)
        mainLayout.addWidget(self.k3,13,6)
        mainLayout.addWidget(self.d4,13,7)
        mainLayout.addWidget(QLabel("40"),14,0)
        mainLayout.addWidget(self.n,14,1)
        mainLayout.addWidget(self.g1,14,2)
        mainLayout.addWidget(self.z1,14,3)
        mainLayout.addWidget(self.s2,14,5)
        mainLayout.addWidget(self.l3,14,6)
        mainLayout.addWidget(self.e4,14,7)
        mainLayout.addWidget(QLabel("50"),15,0)
        mainLayout.addWidget(self.o,15,1)
        mainLayout.addWidget(self.h1,15,2)
        mainLayout.addWidget(self.a2,15,3)
        mainLayout.addWidget(self.t2,15,5)
        mainLayout.addWidget(self.m3,15,6)
        mainLayout.addWidget(self.f4,15,7)
        mainLayout.addWidget(QLabel("60"),16,0)
        mainLayout.addWidget(self.p,16,1)
        mainLayout.addWidget(self.i1,16,2)
        mainLayout.addWidget(self.b2,16,3)
        mainLayout.addWidget(self.u2,16,5)
        mainLayout.addWidget(self.n3,16,6)
        mainLayout.addWidget(self.g4,16,7)
        mainLayout.addWidget(QLabel("70"),17,0)
        mainLayout.addWidget(self.q,17,1)
        mainLayout.addWidget(self.j1,17,2)
        mainLayout.addWidget(self.c2,17,3)
        mainLayout.addWidget(self.v2,17,5)
        mainLayout.addWidget(self.o3,17,6)
        mainLayout.addWidget(self.h4,17,7)
        mainLayout.addWidget(QLabel("80"),18,0)
        mainLayout.addWidget(self.r,18,1)
        mainLayout.addWidget(self.k1,18,2)
        mainLayout.addWidget(self.d2,18,3)
        mainLayout.addWidget(self.w2,18,5)
        mainLayout.addWidget(self.p3,18,6)
        mainLayout.addWidget(self.i4,18,7)
        mainLayout.addWidget(QLabel("90"),19,0)
        mainLayout.addWidget(self.s,19,1)
        mainLayout.addWidget(self.l1,19,2)
        mainLayout.addWidget(self.e2,19,3)
        mainLayout.addWidget(self.x2,19,5)
        mainLayout.addWidget(self.q3,19,6)
        mainLayout.addWidget(self.j4,19,7)
        mainLayout.addWidget(self.resultList,22,0,1,8)
        mainLayout.addWidget(self.graphshow1,20,1)
        mainLayout.addWidget(self.graphshow2,20,2)
        mainLayout.addWidget(self.graphshow3,20,3)
        mainLayout.addWidget(self.graphshow4,20,5)
        mainLayout.addWidget(self.graphshow5,20,6)
        mainLayout.addWidget(self.graphshow6,20,7)
        mainLayout.addWidget(self.calculate1,21,1)
        mainLayout.addWidget(self.calculate2,21,2)
        mainLayout.addWidget(self.calculate3,21,3)
        mainLayout.addWidget(self.calculate4,21,5)
        mainLayout.addWidget(self.calculate5,21,6)
        mainLayout.addWidget(self.calculate6,21,7)

        
        self.setLayout(mainLayout)
        self.setWindowTitle("基礎物理学実験")
        
    def GraphShow1(self):
        
        x1 = np.array([-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90])
        y1 = np.array([float(self.a.text()),float(self.b.text()),float(self.c.text()),float(self.d.text()),float(self.f.text()),float(self.g.text()),float(self.h.text()),float(self.i.text()),float(self.j.text()),float(self.k.text()),float(self.l.text()),float(self.m.text()),float(self.n.text()),float(self.o.text()),float(self.p.text()),float(self.q.text()),float(self.r.text()),float(self.s.text()),float(self.t.text())])
        graph1 = plt.scatter(x1, y1)
        plt.show()

    def GraphShow2(self):
        y2 = np.array([-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90])
        x2 = np.array([float(self.t.text()),float(self.u.text()),float(self.v.text()),float(self.w.text()),float(self.x.text()),float(self.y.text()),float(self.z.text()),float(self.a1.text()),float(self.b1.text()),float(self.c1.text()),float(self.d1.text()),float(self.e1.text()),float(self.f1.text()),float(self.g1.text()),float(self.h1.text()),float(self.i1.text()),float(self.j1.text()),float(self.k1.text()),float(self.l1.text())])
        
        def cos_fit(a,b,c,x):
            return a*cos**2(x+b)+c
        
        param, cov = curve_fit(nonlonear_fit,x2,y2)

        list_y = []
        for num in x2:
            list_y.append(param[0]*np.cos**2(num+param[1])+param[2])
        
        sns.pointplot(x=x2,y=y2,join=False)
        sns.pointplot(x=x2,y=np.array(list_y),markers="")
    
    def GraphShow3(self):
        x2 = np.array([-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90])
        y2 = np.array([float(self.t.text()),float(self.u.text()),float(self.v.text()),float(self.w.text()),float(self.x.text()),float(self.y.text()),float(self.z.text()),float(self.a1.text()),float(self.b1.text()),float(self.c1.text()),float(self.d1.text()),float(self.e1.text()),float(self.f1.text()),float(self.g1.text()),float(self.h1.text()),float(self.i1.text()),float(self.j1.text()),float(self.k1.text()),float(self.l1.text())])
        graph2 = plt.scatter(x2, y2)
        plt.show()
    
    def GraphShow4(self):
        x2 = np.array([-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90])
        y2 = np.array([float(self.t.text()),float(self.u.text()),float(self.v.text()),float(self.w.text()),float(self.x.text()),float(self.y.text()),float(self.z.text()),float(self.a1.text()),float(self.b1.text()),float(self.c1.text()),float(self.d1.text()),float(self.e1.text()),float(self.f1.text()),float(self.g1.text()),float(self.h1.text()),float(self.i1.text()),float(self.j1.text()),float(self.k1.text()),float(self.l1.text())])
        graph2 = plt.scatter(x2, y2)
        plt.show()
    
    def GraphShow5(self):
        x2 = np.array([-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90])
        y2 = np.array([float(self.t.text()),float(self.u.text()),float(self.v.text()),float(self.w.text()),float(self.x.text()),float(self.y.text()),float(self.z.text()),float(self.a1.text()),float(self.b1.text()),float(self.c1.text()),float(self.d1.text()),float(self.e1.text()),float(self.f1.text()),float(self.g1.text()),float(self.h1.text()),float(self.i1.text()),float(self.j1.text()),float(self.k1.text()),float(self.l1.text())])
        graph2 = plt.scatter(x2, y2)
        plt.show()
    
    def GraphShow6(self):
        x2 = np.array([-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90])
        y2 = np.array([float(self.t.text()),float(self.u.text()),float(self.v.text()),float(self.w.text()),float(self.x.text()),float(self.y.text()),float(self.z.text()),float(self.a1.text()),float(self.b1.text()),float(self.c1.text()),float(self.d1.text()),float(self.e1.text()),float(self.f1.text()),float(self.g1.text()),float(self.h1.text()),float(self.i1.text()),float(self.j1.text()),float(self.k1.text()),float(self.l1.text())])
        graph2 = plt.scatter(x2, y2)
        plt.show()

    

    
    def Calculate1(self):
        Ex01_f01_1 = np.array([])
        Ex01_g01_1 = np.array([])
        Ex01_f01_2 = np.array([])
        Ex01_g01_2 = np.array([])
        Ex01_y01_1 = np.array([])
        Ex01_y01_2 = np.array([])
        Ex01_y01 = np.array([float(self.a.text()),float(self.b.text()),float(self.c.text()),float(self.d.text()),float(self.e.text()),float(self.f.text()),float(self.g.text()),float(self.h.text()),float(self.i.text()),float(self.j.text()),float(self.k.text()),float(self.l.text()),float(self.m.text()),float(self.n.text()),float(self.o.text()),float(self.p.text()),float(self.q.text()),float(self.r.text()),float(self.s.text())])
        x = [-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90]
        for i in x:
            Ex01_f01_1 = np.append(Ex01_f01_1,float(math.cos(2*math.radians(i))))
            Ex01_g01_1 = np.append(Ex01_g01_1,float(math.sin(2*math.radians(i))))
            Ex01_f01_2 = np.append(Ex01_f01_2,float((math.cos(2*math.radians(i)))**2))
            Ex01_g01_2 = np.append(Ex01_g01_2,float((math.sin(2*math.radians(i)))**2))
        
        for l in Ex01_y01:
            Ex01_y01_1 = np.append(Ex01_y01_1,float(l-min(Ex01_y01)))
            Ex01_y01_2 = np.append(Ex01_y01_2,float((l-min(Ex01_y01))**2))
        fy = np.dot(Ex01_y01_1,Ex01_f01_1)
        gy = np.dot(Ex01_y01_1,Ex01_g01_1)

        C = (fy-(sum(Ex01_f01_2)/sum(Ex01_f01_1))*sum(Ex01_y01_1))/(sum(Ex01_f01_1)-(sum(Ex01_f01_2)/sum(Ex01_f01_1))*19)
        A = (fy+C)/sum(Ex01_f01_2)
        B = - gy/sum(Ex01_g01_2)

        a = -2*np.sqrt(A**2+B**2)
        b = 0.5*math.atan(B/A)
        c = C-a/2

        ry = np.sqrt((sum(Ex01_y01_2)-A*fy+B*gy-C*sum(Ex01_y01_1))/16)
        rA = (ry*np.sqrt(sum(Ex01_g01_2)*19))/np.sqrt(1701)
        rB = (ry*np.sqrt(sum(Ex01_f01_2)*19)-(sum(Ex01_f01_1))**2)/np.sqrt(1701)
        rC = (ry*np.sqrt(sum(Ex01_g01_2)*sum(Ex01_f01_2)))/np.sqrt(1701)

        aA = 2*A/np.sqrt(A**2+B**2)
        aB = 2*B/np.sqrt(A**2+B**2)
        bA = -0.5*B/np.sqrt(A**2+B**2)
        bB = -0.5*A/np.sqrt(A**2+B**2)
        cC = 1
        ca = -0.5

        ra = np.sqrt(aA**2*rA**2+aB**2*rB**2)
        rb = np.sqrt(bA**2*rA**2+bB**2*rB**2)
        rc = np.sqrt(cC**2*rC**2+ca**2*ra**2)



         
        self.resultList.setText("[f] = "+str(sum(Ex01_f01_1))+" [g] = "+str(sum(Ex01_g01_1))+" [f^2] = "+str(sum(Ex01_f01_2))+" [g^2] = "+str(sum(Ex01_g01_2))+"  [y] = "+str(sum(Ex01_y01_1))+"  [y^2] = "+str(sum(Ex01_y01_2))+" [fy] = "+str(fy)+" [gy] = "+str(gy)+" [h^2] = 19"+" [fh] = "+str(sum(Ex01_f01_1))+" [gh] ≈ [fg] ≈ 0 "+" A = "+str(A)+" B = "+str(B)+" C = "+str(C)+" a = "+str(a)+" b = "+str(b)+" c = "+str(c)+" ry = "+str(ry)+" rA = "+str(rA)+" rB = "+str(rB)+" rC = "+str(rC)+" ∂a/∂A = "+str(aA)+" ∂a/∂B = "+str(aB)+" ∂b/∂A = "+str(bA)+" ∂b/∂B = "+str(bB)+" ∂c/∂C = "+str(cC)+" ∂c/∂Ca = "+str(ca)+" ra = "+str(ra)+" rb = "+str(rb)+" rc = "+str(rc))
            
       
        
    
    def Calculate2(self):
        Ex01_f02_1 = np.array([])
        Ex01_g02_1 = np.array([])
        Ex01_f02_2 = np.array([])
        Ex01_g02_2 = np.array([])
        Ex01_y02_1 = np.array([])
        Ex01_y02_2 = np.array([])
        Ex01_y02 = np.array([float(self.t.text()),float(self.u.text()),float(self.v.text()),float(self.w.text()),float(self.x.text()),float(self.y.text()),float(self.z.text()),float(self.a1.text()),float(self.b1.text()),float(self.c1.text()),float(self.d1.text()),float(self.e1.text()),float(self.f1.text()),float(self.g1.text()),float(self.h1.text()),float(self.i1.text()),float(self.j1.text()),float(self.k1.text()),float(self.l1.text())])
        x = [-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90]
        for i in x:
            Ex01_f02_1 = np.append(Ex01_f02_1,float(math.cos(2*math.radians(i))))
            Ex01_g02_1 = np.append(Ex01_g02_1,float(math.sin(2*math.radians(i))))
            Ex01_f02_2 = np.append(Ex01_f02_2,float((math.cos(2*math.radians(i)))**2))
            Ex01_g02_2 = np.append(Ex01_g02_2,float((math.sin(2*math.radians(i)))**2))
        
        for l in Ex01_y02:
            Ex01_y02_1 = np.append(Ex01_y02_1,float(l-min(Ex01_y02)))
            Ex01_y02_2 = np.append(Ex01_y02_2,float((l-min(Ex01_y02))**2))
        fy = np.dot(Ex01_y02_1,Ex01_f02_1)
        gy = np.dot(Ex01_y02_1,Ex01_g02_1)

        C = (fy-(sum(Ex01_f02_2)/sum(Ex01_f02_1))*sum(Ex01_y02_1))/(sum(Ex01_f02_1)-(sum(Ex01_f02_2)/sum(Ex01_f02_1))*19)
        A = (fy+C)/sum(Ex01_f02_2)
        B = - gy/sum(Ex01_g02_2)

        a = -2*np.sqrt(A**2+B**2)
        b = 0.5*math.atan(B/A)
        c = C-a/2

        ry = np.sqrt((sum(Ex01_y02_2)-A*fy+B*gy-C*sum(Ex01_y02_1))/16)
        rA = (ry*np.sqrt(sum(Ex01_g02_2)*19))/np.sqrt(1701)
        rB = (ry*np.sqrt(sum(Ex01_f02_2)*19)-(sum(Ex01_f02_1))**2)/np.sqrt(1701)
        rC = (ry*np.sqrt(sum(Ex01_g02_2)*sum(Ex01_f02_2)))/np.sqrt(1701)

        aA = 2*A/np.sqrt(A**2+B**2)
        aB = 2*B/np.sqrt(A**2+B**2)
        bA = -0.5*B/np.sqrt(A**2+B**2)
        bB = -0.5*A/np.sqrt(A**2+B**2)
        cC = 1
        ca = -0.5

        ra = np.sqrt(aA**2*rA**2+aB**2*rB**2)
        rb = np.sqrt(bA**2*rA**2+bB**2*rB**2)
        rc = np.sqrt(cC**2*rC**2+ca**2*ra**2)
       
        self.resultList.setText("[f] = "+str(sum(Ex01_f02_1))+" [g] = "+str(sum(Ex01_g02_1))+" [f^2] = "+str(sum(Ex01_f02_2))+" [g^2] = "+str(sum(Ex01_g02_2))+"  [y] = "+str(sum(Ex01_y02_1))+"  [y^2] = "+str(sum(Ex01_y02_2))+" [fy] = "+str(fy)+" [gy] = "+str(gy)+" [h^2] = 19"+" [fh] = "+str(sum(Ex01_f02_1))+" [gh] ≈ [fg] ≈ 0 "+" A = "+str(A)+" B = "+str(B)+" C = "+str(C)+" a = "+str(a)+" b = "+str(b)+" c = "+str(c)+" ry = "+str(ry)+" rA = "+str(rA)+" rB = "+str(rB)+" rC = "+str(rC)+" ∂a/∂A = "+str(aA)+" ∂a/∂B = "+str(aB)+" ∂b/∂A = "+str(bA)+" ∂b/∂B = "+str(bB)+" ∂c/∂C = "+str(cC)+" ∂c/∂Ca = "+str(ca)+" ra = "+str(ra)+" rb = "+str(rb)+" rc = "+str(rc))
    
    def Calculate3(self):
        Ex01_f03_1 = np.array([])
        Ex01_g03_1 = np.array([])
        Ex01_f03_2 = np.array([])
        Ex01_g03_2 = np.array([])
        Ex01_y03_1 = np.array([])
        Ex01_y03_2 = np.array([])
        Ex01_y03 = np.array([float(self.m1.text()),float(self.n1.text()),float(self.o1.text()),float(self.p1.text()),float(self.q1.text()),float(self.r1.text()),float(self.s1.text()),float(self.t1.text()),float(self.u1.text()),float(self.v1.text()),float(self.w1.text()),float(self.x1.text()),float(self.y1.text()),float(self.z1.text()),float(self.a2.text()),float(self.b2.text()),float(self.c2.text()),float(self.d2.text()),float(self.e2.text())])
        x = [-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90]
        for i in x:
            Ex01_f03_1 = np.append(Ex01_f03_1,float(math.cos(2*math.radians(i))))
            Ex01_g03_1 = np.append(Ex01_g03_1,float(math.sin(2*math.radians(i))))
            Ex01_f03_2 = np.append(Ex01_f03_2,float((math.cos(2*math.radians(i)))**2))
            Ex01_g03_2 = np.append(Ex01_g03_2,float((math.sin(2*math.radians(i)))**2))
        
        for l in Ex01_y03:
            Ex01_y03_1 = np.append(Ex01_y03_1,float(l-min(Ex01_y03)))
            Ex01_y03_2 = np.append(Ex01_y03_2,float((l-min(Ex01_y03))**2))
        fy = np.dot(Ex01_y03_1,Ex01_f03_1)
        gy = np.dot(Ex01_y03_1,Ex01_g03_1)

        C = (fy-(sum(Ex01_f03_2)/sum(Ex01_f03_1))*sum(Ex01_y03_1))/(sum(Ex01_f03_1)-(sum(Ex01_f03_2)/sum(Ex01_f03_1))*19)
        A = (fy+C)/sum(Ex01_f03_2)
        B = - gy/sum(Ex01_g03_2)

        a = -2*np.sqrt(A**2+B**2)
        b = 0.5*math.atan(B/A)
        c = C-a/2

        ry = np.sqrt((sum(Ex01_y03_2)-A*fy+B*gy-C*sum(Ex01_y03_1))/16)
        rA = (ry*np.sqrt(sum(Ex01_g03_2)*19))/np.sqrt(1701)
        rB = (ry*np.sqrt(sum(Ex01_f03_2)*19)-(sum(Ex01_f03_1))**2)/np.sqrt(1701)
        rC = (ry*np.sqrt(sum(Ex01_g03_2)*sum(Ex01_f03_2)))/np.sqrt(1701)

        aA = 2*A/np.sqrt(A**2+B**2)
        aB = 2*B/np.sqrt(A**2+B**2)
        bA = -0.5*B/np.sqrt(A**2+B**2)
        bB = -0.5*A/np.sqrt(A**2+B**2)
        cC = 1
        ca = -0.5

        ra = np.sqrt(aA**2*rA**2+aB**2*rB**2)
        rb = np.sqrt(bA**2*rA**2+bB**2*rB**2)
        rc = np.sqrt(cC**2*rC**2+ca**2*ra**2)
       
        self.resultList.setText("[f] = "+str(sum(Ex01_f03_1))+" [g] = "+str(sum(Ex01_g03_1))+" [f^2] = "+str(sum(Ex01_f03_2))+" [g^2] = "+str(sum(Ex01_g03_2))+"  [y] = "+str(sum(Ex01_y03_1))+"  [y^2] = "+str(sum(Ex01_y03_2))+" [fy] = "+str(fy)+" [gy] = "+str(gy)+" [h^2] = 19"+" [fh] = "+str(sum(Ex01_f03_1))+" [gh] ≈ [fg] ≈ 0 "+" A = "+str(A)+" B = "+str(B)+" C = "+str(C)+" a = "+str(a)+" b = "+str(b)+" c = "+str(c)+" ry = "+str(ry)+" rA = "+str(rA)+" rB = "+str(rB)+" rC = "+str(rC)+" ∂a/∂A = "+str(aA)+" ∂a/∂B = "+str(aB)+" ∂b/∂A = "+str(bA)+" ∂b/∂B = "+str(bB)+" ∂c/∂C = "+str(cC)+" ∂c/∂Ca = "+str(ca)+" ra = "+str(ra)+" rb = "+str(rb)+" rc = "+str(rc))


    def Calculate4(self):
        Ex02_f01_1 = np.array([])
        Ex02_g01_1 = np.array([])
        Ex02_f01_2 = np.array([])
        Ex02_g01_2 = np.array([])
        Ex02_y01_1 = np.array([])
        Ex02_y01_2 = np.array([])
        Ex02_y01 = np.array([float(self.f2.text()),float(self.g2.text()),float(self.h2.text()),float(self.i2.text()),float(self.j2.text()),float(self.k2.text()),float(self.l2.text()),float(self.m2.text()),float(self.n2.text()),float(self.o2.text()),float(self.p2.text()),float(self.q2.text()),float(self.r2.text()),float(self.s2.text()),float(self.t2.text()),float(self.u2.text()),float(self.v2.text()),float(self.w2.text()),float(self.x2.text())])
        x = [-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90]
        for i in x:
            Ex02_f01_1 = np.append(Ex02_f01_1,float(math.cos(2*math.radians(i))))
            Ex02_g01_1 = np.append(Ex02_g01_1,float(math.sin(2*math.radians(i))))
            Ex02_f01_2 = np.append(Ex02_f01_2,float((math.cos(2*math.radians(i)))**2))
            Ex02_g01_2 = np.append(Ex02_g01_2,float((math.sin(2*math.radians(i)))**2))
        
        for l in Ex02_y01:
            Ex02_y01_1 = np.append(Ex02_y01_1,float(l-min(Ex02_y01)))
            Ex02_y01_2 = np.append(Ex02_y01_2,float((l-min(Ex02_y01))**2))
        fy = np.dot(Ex02_y01_1,Ex02_f01_1)
        gy = np.dot(Ex02_y01_1,Ex02_g01_1)
        
        C = (fy-(sum(Ex02_f01_2)/sum(Ex02_f01_1))*sum(Ex02_y01_1))/(sum(Ex02_f01_1)-(sum(Ex02_f01_2)/sum(Ex02_f01_1))*19)
        A = (fy+C)/sum(Ex02_f01_2)
        B = - gy/sum(Ex02_g01_2)

        a = -2*np.sqrt(A**2+B**2)
        b = 0.5*math.atan(B/A)
        c = C-a/2

        ry = np.sqrt((sum(Ex02_y01_2)-A*fy+B*gy-C*sum(Ex02_y01_1))/16)
        rA = (ry*np.sqrt(sum(Ex02_g01_2)*19))/np.sqrt(1701)
        rB = (ry*np.sqrt(sum(Ex02_f01_2)*19)-(sum(Ex02_f01_1))**2)/np.sqrt(1701)
        rC = (ry*np.sqrt(sum(Ex02_g01_2)*sum(Ex02_f01_2)))/np.sqrt(1701)

        aA = 2*A/np.sqrt(A**2+B**2)
        aB = 2*B/np.sqrt(A**2+B**2)
        bA = -0.5*B/np.sqrt(A**2+B**2)
        bB = -0.5*A/np.sqrt(A**2+B**2)
        cC = 1
        ca = -0.5

        ra = np.sqrt(aA**2*rA**2+aB**2*rB**2)
        rb = np.sqrt(bA**2*rA**2+bB**2*rB**2)
        rc = np.sqrt(cC**2*rC**2+ca**2*ra**2)
        self.resultList.setText("[f] = "+str(sum(Ex02_f01_1))+" [g] = "+str(sum(Ex02_g01_1))+" [f^2] = "+str(sum(Ex02_f01_2))+" [g^2] = "+str(sum(Ex02_g01_2))+"  [y] = "+str(sum(Ex02_y01_1))+"  [y^2] = "+str(sum(Ex02_y01_2))+" [fy] = "+str(fy)+" [gy] = "+str(gy)+" [h^2] = 19"+" [fh] = "+str(sum(Ex02_f01_1))+" [gh] ≈ [fg] ≈ 0 "+" A = "+str(A)+" B = "+str(B)+" C = "+str(C)+" a = "+str(a)+" b = "+str(b)+" c = "+str(c)+" ry = "+str(ry)+" rA = "+str(rA)+" rB = "+str(rB)+" rC = "+str(rC)+" ∂a/∂A = "+str(aA)+" ∂a/∂B = "+str(aB)+" ∂b/∂A = "+str(bA)+" ∂b/∂B = "+str(bB)+" ∂c/∂C = "+str(cC)+" ∂c/∂Ca = "+str(ca)+" ra = "+str(ra)+" rb = "+str(rb)+" rc = "+str(rc))


    def Calculate5(self):
        Ex02_f02_1 = np.array([])
        Ex02_g02_1 = np.array([])
        Ex02_f02_2 = np.array([])
        Ex02_g02_2 = np.array([])
        Ex02_y02_1 = np.array([])
        Ex02_y02_2 = np.array([])
        Ex02_y02 = np.array([float(self.y2.text()),float(self.z2.text()),float(self.a3.text()),float(self.b3.text()),float(self.c3.text()),float(self.d3.text()),float(self.e3.text()),float(self.f3.text()),float(self.g3.text()),float(self.h3.text()),float(self.i3.text()),float(self.j3.text()),float(self.k3.text()),float(self.l3.text()),float(self.m3.text()),float(self.n3.text()),float(self.o3.text()),float(self.p3.text()),float(self.q3.text())])
        x = [-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90]
        for i in x:
            Ex02_f02_1 = np.append(Ex02_f02_1,float(math.cos(2*math.radians(i))))
            Ex02_g02_1 = np.append(Ex02_g02_1,float(math.sin(2*math.radians(i))))
            Ex02_f02_2 = np.append(Ex02_f02_2,float((math.cos(2*math.radians(i)))**2))
            Ex02_g02_2 = np.append(Ex02_g02_2,float((math.sin(2*math.radians(i)))**2))
        
        for l in Ex02_y02:
            Ex02_y02_1 = np.append(Ex02_y02_1,float(l-min(Ex02_y02)))
            Ex02_y02_2 = np.append(Ex02_y02_2,float((l-min(Ex02_y02))**2))
        fy = np.dot(Ex02_y02_1,Ex02_f02_1)
        gy = np.dot(Ex02_y02_1,Ex02_g02_1)

        C = (fy-(sum(Ex02_f02_2)/sum(Ex02_f02_1))*sum(Ex02_y02_1))/(sum(Ex02_f02_1)-(sum(Ex02_f02_2)/sum(Ex02_f02_1))*19)
        A = (fy+C)/sum(Ex02_f02_2)
        B = - gy/sum(Ex02_g02_2)

        a = -2*np.sqrt(A**2+B**2)
        b = 0.5*math.atan(B/A)
        c = C-a/2

        ry = np.sqrt((sum(Ex02_y02_2)-A*fy+B*gy-C*sum(Ex02_y02_1))/16)
        rA = (ry*np.sqrt(sum(Ex02_g02_2)*19))/np.sqrt(1701)
        rB = (ry*np.sqrt(sum(Ex02_f02_2)*19)-(sum(Ex02_f02_1))**2)/np.sqrt(1701)
        rC = (ry*np.sqrt(sum(Ex02_g02_2)*sum(Ex02_f02_2)))/np.sqrt(1701)

        aA = 2*A/np.sqrt(A**2+B**2)
        aB = 2*B/np.sqrt(A**2+B**2)
        bA = -0.5*B/np.sqrt(A**2+B**2)
        bB = -0.5*A/np.sqrt(A**2+B**2)
        cC = 1
        ca = -0.5

        ra = np.sqrt(aA**2*rA**2+aB**2*rB**2)
        rb = np.sqrt(bA**2*rA**2+bB**2*rB**2)
        rc = np.sqrt(cC**2*rC**2+ca**2*ra**2)
        self.resultList.setText("[f] = "+str(sum(Ex02_f02_1))+" [g] = "+str(sum(Ex02_g02_1))+" [f^2] = "+str(sum(Ex02_f02_2))+" [g^2] = "+str(sum(Ex02_g02_2))+"  [y] = "+str(sum(Ex02_y02_1))+"  [y^2] = "+str(sum(Ex02_y02_2))+" [fy] = "+str(fy)+" [gy] = "+str(gy)+" [h^2] = 19"+" [fh] = "+str(sum(Ex02_f02_1))+" [gh] ≈ [fg] ≈ 0 "+" A = "+str(A)+" B = "+str(B)+" C = "+str(C)+" a = "+str(a)+" b = "+str(b)+" c = "+str(c)+" ry = "+str(ry)+" rA = "+str(rA)+" rB = "+str(rB)+" rC = "+str(rC)+" ∂a/∂A = "+str(aA)+" ∂a/∂B = "+str(aB)+" ∂b/∂A = "+str(bA)+" ∂b/∂B = "+str(bB)+" ∂c/∂C = "+str(cC)+" ∂c/∂Ca = "+str(ca)+" ra = "+str(ra)+" rb = "+str(rb)+" rc = "+str(rc))


    def Calculate6(self):
        Ex02_f03_1 = np.array([])
        Ex02_g03_1 = np.array([])
        Ex02_f03_2 = np.array([])
        Ex02_g03_2 = np.array([])
        Ex02_y03_1 = np.array([])
        Ex02_y03_2 = np.array([])
        Ex02_y03 = np.array([float(self.r3.text()),float(self.s3.text()),float(self.t3.text()),float(self.u3.text()),float(self.v3.text()),float(self.w3.text()),float(self.x3.text()),float(self.y3.text()),float(self.z3.text()),float(self.a4.text()),float(self.b4.text()),float(self.c4.text()),float(self.d4.text()),float(self.e4.text()),float(self.f4.text()),float(self.g4.text()),float(self.h4.text()),float(self.i4.text()),float(self.j4.text())])
        x = [-90,-80,-70,-60,-50,-40,-30,-20,-10,0,10,20,30,40,50,60,70,80,90]
        for i in x:
            Ex02_f03_1 = np.append(Ex02_f03_1,float(math.cos(2*math.radians(i))))
            Ex02_g03_1 = np.append(Ex02_g03_1,float(math.sin(2*math.radians(i))))
            Ex02_f03_2 = np.append(Ex02_f03_2,float((math.cos(2*math.radians(i)))**2))
            Ex02_g03_2 = np.append(Ex02_g03_2,float((math.sin(2*math.radians(i)))**2))
        
        for l in Ex02_y03:
            Ex02_y03_1 = np.append(Ex02_y03_1,float(l-min(Ex02_y03)))
            Ex02_y03_2 = np.append(Ex02_y03_2,float((l-min(Ex02_y03))**2))
        fy = np.dot(Ex02_y03_1,Ex02_f03_1)
        gy = np.dot(Ex02_y03_1,Ex02_g03_1)

        C = (fy-(sum(Ex02_f03_2)/sum(Ex02_f03_1))*sum(Ex02_y03_1))/(sum(Ex02_f03_1)-(sum(Ex02_f03_2)/sum(Ex02_f03_1))*19)
        A = (fy+C)/sum(Ex02_f03_2)
        B = - gy/sum(Ex02_g03_2)

        a = -2*np.sqrt(A**2+B**2)
        b = 0.5*math.atan(B/A)
        c = C-a/2

        ry = np.sqrt((sum(Ex02_y03_2)-A*fy+B*gy-C*sum(Ex02_y03_1))/16)
        rA = (ry*np.sqrt(sum(Ex02_g03_2)*19))/np.sqrt(1701)
        rB = (ry*np.sqrt(sum(Ex02_f03_2)*19)-(sum(Ex02_f03_1))**2)/np.sqrt(1701)
        rC = (ry*np.sqrt(sum(Ex02_g03_2)*sum(Ex02_f03_2)))/np.sqrt(1701)

        aA = 2*A/np.sqrt(A**2+B**2)
        aB = 2*B/np.sqrt(A**2+B**2)
        bA = -0.5*B/np.sqrt(A**2+B**2)
        bB = -0.5*A/np.sqrt(A**2+B**2)
        cC = 1
        ca = -0.5

        ra = np.sqrt(aA**2*rA**2+aB**2*rB**2)
        rb = np.sqrt(bA**2*rA**2+bB**2*rB**2)
        rc = np.sqrt(cC**2*rC**2+ca**2*ra**2)
        self.resultList.setText("[f] = "+str(sum(Ex02_f03_1))+" [g] = "+str(sum(Ex02_g03_1))+" [f^2] = "+str(sum(Ex02_f03_2))+" [g^2] = "+str(sum(Ex02_g03_2))+"  [y] = "+str(sum(Ex02_y03_1))+"  [y^2] = "+str(sum(Ex02_y03_2))+" [fy] = "+str(fy)+" [gy] = "+str(gy)+" [h^2] = 19"+" [fh] = "+str(sum(Ex02_f03_1))+" [gh] ≈ [fg] ≈ 0 "+" A = "+str(A)+" B = "+str(B)+" C = "+str(C)+" a = "+str(a)+" b = "+str(b)+" c = "+str(c)+" ry = "+str(ry)+" rA = "+str(rA)+" rB = "+str(rB)+" rC = "+str(rC)+" ∂a/∂A = "+str(aA)+" ∂a/∂B = "+str(aB)+" ∂b/∂A = "+str(bA)+" ∂b/∂B = "+str(bB)+" ∂c/∂C = "+str(cC)+" ∂c/∂Ca = "+str(ca)+" ra = "+str(ra)+" rb = "+str(rb)+" rc = "+str(rc))
        
if __name__ == "__main__":
    import sys
    app = QApplication(sys.argv)
    main_window = MainWindow()
    main_window.show()
    sys.exit(app.exec_())